require_dependency "rechn_mgm_user_area/application_controller"

# TODO: Think whether move the implementation specific part (roles, favorites) to rechn_mgm_web? (se)
module RechnMgmUserArea
    class UsersController < AuthenticatedController
        layout 'application'
        protect_from_forgery except: :set_favorite, prepend: true #, with: :exception, unless: -> { request.format.json? }
        before_action :set_user, only: [:show, :edit, :update]
        before_action :set_previous_payments, only: [:show, :edit, :update]

        # GET /users/1/edit
        def edit
        end

        def update
            if @user.update(user_params)
                #redirect_to @document, notice: 'Document was successfully created.'
                render :edit
            else
                flash[:error] = "Die Daten konnten nicht gespeichert werden."
                render :edit
            end
        end

        def index
            @users = DeviseAuthentication::User.all
        end

        def show
        end

        def favorites
            @user = current_user
        end

        def set_favorite
            @error   = 0
            @message = "success"
            if DeviseAuthentication::User.where(id: direct_params[:id]).blank?
                @error = 1
                @message = "User could not be found in database."
            end

            if @error == 0 && !current_user.favorites.include?(direct_params[:id])
                current_user.favorites.push direct_params[:id]
                if !current_user.save
                    @error = 2
                    @message = "Unable to save: #{current_user.errors[:messages]}"
                end
            end
        end

        def remove_favorite
            @error   = 0
            @message = "success"
            current_user.favorites.delete(direct_params[:id])
            if !current_user.save
                @error = 2
                @message = "Unable to save: #{current_user.errors[:messages]}"
            end
        end

        def destroy
            #byebug
            # TODO: Implement me!
            redirect_to "/logout"
        end

        private
        # Use callbacks to share common setup or constraints between actions.
        def set_user
            @user = DeviseAuthentication::User.find(params[:id])
        end

        def set_previous_payments
            @previous_payments = []
        end

        # Only allow a trusted parameter "white list" through.
        def direct_params
            params.permit(:id)
        end

        def user_params
            params.require(:user).permit(:id, :email, :forename, :lastname, :company, :street, :street_no, :zipcode, :city, :return_address)
        end
    end
end
