# Decorator to add some special features to a User
# TODO: This is a strong relationship to DeviseAuthentication and will to stop work if we use anything different!! (se)
# TODO: Think whether move the implementation specific part (roles, favorites) to rechn_mgm_web? (se)
DeviseAuthentication::User.class_eval do
    #.             1     2           4
    ROLES     = %w[admin buchhaltung sachbearbeiter]

    field :forename,        :type => String, :required => true
    field :lastname,        :type => String, :required => true
    field :company,         :type => String
    field :street,          :type => String
    field :street_no,       :type => String
    field :zipcode,         :type => String
    field :city,            :type => String
    field :return_address,  :type => String
    ## User Role
    field :roles_mask,      :type => Integer,   :default => 4, :validates => { numericality: { greater_than: 0 } }
    field :favorites,       :type => Array,     :default => []                                                              # List of user_id

    def user_name
        "#{self.forename} #{self.lastname}"
    end

    def is?(role)
        roles.include?(role.to_s)
    end

    def roles=(roles)
        self.roles_mask = (roles & ROLES).map { |r| 2**ROLES.index(r) }.inject(0, :+)
    end

    def roles
        ROLES.reject do |r|
            ((roles_mask.to_i || 0) & 2**ROLES.index(r)).zero?
        end
    end

end
